TODOS:
=============================

* Make callstack inspection less brittle by checking ancestry, etc.
* MOAR CanCan!!1!
* Support for different frameworks (refactor as Rack app?):
  * Rails
  * Sinatra

Ideal End-user API:
=============================

    # app/controllers/users_controller.rb

    class UsersController < ApplicationController

      def show
        if FeatureSet(:feature_name).visible?
          # do something
        end
      end

    end

    # app/views/users/show.html.haml

    %h2= User #{username}
    - if FeatureSet(:user_profile_pic).visible?
      = render :partial => '_profile_pic'

    # config/initializers/features.rb

    FeatureSet.define :user_profile_pic do |f|
      f.show do
        current_user? || (%w{test development}.include? Rails.env)
      end

      f.show 'users#show'
      f.show 'users#destroy'
      f.show 'users#create' do 
        current_user?
      end

      f.hide 'users#index'
      f.hide 'users#update'
      f.hide 'users#create' do
        if current_user?
      end
    end

Jurisdiction Object:
=============================

    Sheriff::Jurisdiction.new *args                  # <= accept any arguments that CanCan will understand
    Sheriff::Jurisdiction.new UsersController        # <= ability to execute any public method on UsersController
    Sheriff::Jurisdiction.new 'UsersController#show' # <= ability to execute show on the UsersController
    Sheriff::Jurisdiction.new 'users/show'           # <= ability to view route 'users/show'
    Sheriff::Jurisdiction.new users_path             # <= ability to view users_path
    Sheriff::Jurisdiction.new user_path(1)           # <= ability to view path for user with id=1

